/// <reference types="graphql" />
import { MutationQueryReducersMap } from 'apollo-client';
import { DocumentNode } from 'graphql';
export interface MutationOptions {
    variables?: Object;
    optimisticResponse?: Object;
    updateQueries?: MutationQueryReducersMap;
    forceFetch?: boolean;
}
export interface QueryOptions {
    ssr?: boolean;
    variables?: {
        [key: string]: any;
    };
    forceFetch?: boolean;
    returnPartialData?: boolean;
    noFetch?: boolean;
    pollInterval?: number;
    skip?: boolean;
}
export declare function withApollo(WrappedComponent: any, operationOptions?: OperationOption): any;
export interface OperationOption {
    options?: Object | ((props: any) => QueryOptions | MutationOptions);
    props?: (props: any) => any;
    skip?: boolean | ((props: any) => boolean);
    name?: string;
    withRef?: boolean;
    shouldResubscribe?: (props: any, nextProps: any) => boolean;
    alias?: string;
}
export default function graphql(document: DocumentNode, operationOptions?: OperationOption): (WrappedComponent: any) => any;
